/*****************************************************************************

PACKET.H	

Copyright (C) 1990
	Elo TouchSystems, Inc.
	105 Randolph Road
	Oak Ridge, TN  37830
	(615) 482-4100

Written on August 23, 1990 by Lawrence Adams.

*****************************************************************************/

#define 	_2200_ 	0							/* smartset controller types */
#define  _2210_	1
#define  _2300_	2
#define  _2201_	3
#define  _2301_	4
#define  _2202_	5
#define  _2302_	6
#define  _2310_	7
#define  _2310B_	8
#define  _2500_	9

#define	_SERIAL_	'0'						/* interface types */
#define	_PCBUS_	'1'
#define	_MCA_		'2'

#define _ACCU_		'0'						/* touchscreen types */
#define _DURA_		'1'
#define _INTELLI_	'2'

#define	OK					0					/* communication errors */
#define	NOCONTROLLER	1
#define	SHORTED			2
#define	NOMCA				3
#define	CANTSEND			4
#define	NORESPONSE		5
#define	WRONGRESPONSE	6
#define	NOPCBUS			7
#define	NOUPLOAD			51
#define  NOACK				52
#define  NOCOMM			53
#define  MCACOMM			54
#define  NOCHANGE			55
#define	NOMCACONTROLLER 56
#define  NOCOMPARE		57

#define	NOOPEN			101				/* disk errors */
#define	NOREAD			102
#define	NOFILE			103
#define	WRONGVERSION	104
#define	NOCREATE			105
#define  NOINFO			106
#define  NOSETUP			107
#define  NOCAL2			108

#define	ACKERR			200				/* errors returnd in ack. packet + 200 */
#define  NOWARNING		248				/* '0' */
#define  DIVZER			249				/* '1' */
#define	BADINP			250				/* '2' */
#define	BADCRC			251				/* '3' */
#define	OVRRUN			252				/* '4' */
#define	ILLCMD			253				/* '5' */
#define	CALIBCANCL		254				/* '6' */
#define  RESERVED1		255				/* '7' */
#define	BADSERSETUP		256				/* '8' */
#define	EEPROM			257				/* '9' */
#define	NOSET				265				/* 'A' */
#define	UNSUPP			266				/* 'B' */
#define	ILLSUB			267				/* 'C' */
#define	OUTOFRANGE		268				/* 'D' */
#define	INVTYPE			269				/* 'E' */
#define	FATALERR			270				/* 'F' */
#define  NOQUERY			271				/* 'G' */
#define  INVINT			272				/* 'H' */
#define  NVRAMFAIL		273				/* 'I' */
#define	BADADDRESS		274				/* 'J' */

extern packettype								
	report, calibs, calibpx, calibpy, calibpz, emulate, filtr, 
	usrtimer, id, jumpers, keychar, lowpwr, tmode, nvm, owner, 
	params, quiet, scales, scalepx, scalepy, scalepz;

extern packettype
	ack, calibrx, calibry, calibrz, diag, reset, scalerx, scalery, 
	scalerz,	touch;	

extern packettype
	dfltserparams, dfltbusparams, dfltmcaparams, lastparams;

extern unsigned 
	interfacetype, screentype, controllertype;

int		initcontroller(void);
int		clearcontroller(void);
boolean	getsmartsetpacket(packettype packet, byte p);
boolean	getanysmartsetpacket(packettype packet);
int		getanyASCIIpacket(char *packet, int maxlength, boolean lfstop);
boolean	getanyotherbinarypacket(packettype packet);
boolean	sendsmartsetpacket(packettype packet);
void		closesmartsetcontroller(void);
char 		*errormsg(int errnum);

